/* signal.c
 * Signal-handling routines for gensig
 */
#include <stdio.h>
#include <signal.h>
#include "gensig.h"

extern int logout_flag;
extern int ppid;		/* Pid of parent (shell) */

/* quit_handler()
 * Handle a signal; set logout_flag to 1 so that the main loop will
 * exit.
 */
void quit_handler()
{
	logout_flag = 1;
}

/* ignore_handler()
 * Handle a signal by ignoring it.
 */
void ignore_handler()
{
	return;
}

void ALRM_handler()
{
#ifdef DEBUG
	fprintf(stderr, "Got a ALRM.\n");
#endif
	/* Check to make sure the shell still exists */
	if (kill(ppid, 0) < 0)
	{
		logout_flag = 1;
		return;
	}

	/* And reset the alarm */
	alarm(TIMEOUT);
}

int init_signals()
{
	signal(SIGHUP, quit_handler);
	signal(SIGPIPE, ignore_handler);
	signal(SIGALRM, ALRM_handler);
	signal(SIGTERM, quit_handler);
}
